<?php

class Zenbu_edit_link_ext {

    var $name           = 'Zenbu Edit Link';
    var $version        = '1.0b';
    var $description    = 'Add a default edit link';
    var $settings_exist = 'n';
    var $docs_url       = 'http://reinos.nl/add-ons/zenbu-edit-link';

    var $settings       = array();

    /**
     * Constructor
     *
     * @param   mixed   Settings array or empty string if none exist.
     */
    function __construct($settings = '')
    {
        $this->EE =& get_instance();

        $this->settings = $settings;

		ee()->lang->loadfile('zenbu_edit_link');
    }

    /**
    * Activate Extension
    *
    * This function enters the extension into the exp_extensions table
    *
    * @see http://codeigniter.com/user_guide/database/index.html for
    * more information on the db class.
    *
    * @return void
    */
    function activate_extension()
    {
        $data = array(
            'class'     => __CLASS__,
            'method'    => 'zenbu_add_column',
            'hook'      => 'zenbu_add_column',
            'settings'  => serialize($this->settings),
            'priority'  => 10,
            'version'   => $this->version,
            'enabled'   => 'y'
        );

        $this->EE->db->insert('extensions', $data);

		$data = array(
			'class'     => __CLASS__,
			'method'    => 'zenbu_entry_cell_data',
			'hook'      => 'zenbu_entry_cell_data',
			'settings'  => serialize($this->settings),
			'priority'  => 10,
			'version'   => $this->version,
			'enabled'   => 'y'
		);

		$this->EE->db->insert('extensions', $data);
    }

    /**
    * Update Extension
    *
    * This function performs any necessary db updates when the extension
    * page is visited
    *
    * @return  mixed   void on update / false if none
    */
    function update_extension($current = '')
    {
        if ($current == '' OR $current == $this->version)
        {
            return FALSE;
        }

        $this->EE->db->where('class', __CLASS__);
        $this->EE->db->update(
            'extensions',
            array('version' => $this->version)
        );
    }

    /**
    * Disable Extension
    *
    * This method removes information from the exp_extensions table
    *
    * @return void
    */
    function disable_extension()
    {
        $this->EE->db->where('class', __CLASS__);
        $this->EE->db->delete('extensions');
    }

    /**
    * zenbu_add_column method
    *
    * Add a new column for zenbu
    *
    * @return void
    */
    function zenbu_add_column()
    {
		$hook_fields_and_labels[] = array(
			'column'    => 'show_edit_link',
			'label'     => ee()->lang->line('show_edit_link'),
		);

		return $hook_fields_and_labels;
    }

	/**
	 * zenbu_entry_cell_data method
	 *
	 * Add the data to the list
	 *
	 * @return void
	 */
	function zenbu_entry_cell_data($entry_id, $entry_array, $channel_id)
	{
		$perpage = ($this->EE->session->cache('zenbu', 'perpage')) ? ($this->EE->session->cache('zenbu', 'perpage')) : $this->EE->input->get_post('perpage', TRUE);
		$perpage = (empty($perpage)) ? 0 : $perpage;

		// Build filter for entry title link
		$filter_array	= array("return_to_zenbu" => "y", "perpage" => $perpage);
		$filter_array	= base64_encode(serialize($filter_array));

		//create te link and output it
		$output["edit_link"] = anchor(BASE.AMP."C=content_publish".AMP."M=entry_form".AMP."channel_id=".$channel_id.AMP."entry_id=".$entry_id.AMP."filter=".$filter_array, ee()->lang->line('edit'), 'class="zenbu_entry_form_link"');
		return $output;
	}

}
// END CLASS